﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataChartTooltipCodeBehindCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        ViewModel VM = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();

            XamDataChart chart = new XamDataChart();

            NumericXAxis xAxis = new NumericXAxis() { MinimumValue = 0, MaximumValue = 25 };
            NumericYAxis yAxis = new NumericYAxis() { MinimumValue = 0, MaximumValue = 20 };

            chart.Axes.Add(xAxis);
            chart.Axes.Add(yAxis);

            ScatterLineSeries sls1 = new ScatterLineSeries()
            {
                XAxis = xAxis,
                YAxis = yAxis,
                ItemsSource = VM.ScatterData1,
                XMemberPath = "XValue",
                YMemberPath = "YValue",
                Brush = Brushes.Red,
                MarkerBrush = Brushes.Red,
                ToolTip = GetTooltip(),
                Title = "Series 1"
            };

            ScatterLineSeries sls2 = new ScatterLineSeries()
            {
                XAxis = xAxis,
                YAxis = yAxis,
                ItemsSource = VM.ScatterData2,
                XMemberPath = "XValue",
                YMemberPath = "YValue",
                Brush = Brushes.Blue,
                MarkerBrush = Brushes.Blue,
                ToolTip = GetTooltip(),
                Title = "Series 2"
            };

            chart.Series.Add(sls1);
            chart.Series.Add(sls2);

            LayoutRoot.Children.Add(chart);

        }


        public ContentControl GetTooltip()
        {
            ContentControl cc = new ContentControl();

            StackPanel ParentStack = new StackPanel();

            TextBlock titleBlock = new TextBlock();
            titleBlock.FontWeight = FontWeights.Bold;
            titleBlock.SetBinding(TextBlock.TextProperty, new Binding("Series.Title"));            

            StackPanel XStack = new StackPanel() { Orientation = Orientation.Horizontal };
            TextBlock xLabel = new TextBlock() { Text = "X Value: " };
            TextBlock xValue = new TextBlock();
            xValue.SetBinding(TextBlock.TextProperty, new Binding("Item.XValue"));
            XStack.Children.Add(xLabel);
            XStack.Children.Add(xValue);

            StackPanel YStack = new StackPanel() { Orientation = Orientation.Horizontal };
            TextBlock yLabel = new TextBlock() { Text = "Y Value: " };
            TextBlock yValue = new TextBlock();
            yValue.SetBinding(TextBlock.TextProperty, new Binding("Item.YValue"));
            YStack.Children.Add(yLabel);
            YStack.Children.Add(yValue);

            ParentStack.Children.Add(titleBlock);
            ParentStack.Children.Add(XStack);
            ParentStack.Children.Add(YStack);

            cc.Content = ParentStack;

            return cc;
        }
    }
}
